// -*- C++ -*-
//
// sampleana.cc
// Template source file
//
// Author:  
// Created: 
//
// $Id$
//
// Revision History
//
// $Log$
//

#include <iostream>
#include <iomanip>
#include "MidasManager/MidasBank.h"
#include "MidasManager/MidasFileIO.h"
#include "e391user.h"

// globals
MidasBank  mbank;
int  RunNumber = 0;

////////
// main
int
main( int argc, char* argv[] )
{
  if ( argc < 2 ){
    std::cerr << "usage : " << argv[0] << " filename" << std::endl;
    return( 1 );
  }
  //
  user_init();

  for( int i=1;i<argc;i++ ){
    // open data file
    MidasFileIO  mfile( argv[1],O_RDONLY|O_LARGEFILE );
    if ( mfile.good() ){
      mfile.bank( mbank );
      std::cerr << "opening " << argv[1] << std::endl;

      // event bank
      EVENT_HEADER*  pheader = mbank.eventHeader();
      void*          pevent  = mbank.eventBuffer();

      // Process Begin_of_run record
      if ( mfile.readBOR() ){
        RunNumber = mbank.runNumber();
        std::cout << "Run=" << RunNumber << std::endl;
        // get DB for this run
        //e391det.getDB( RunNumber );
        //e391det.getDB( 1 );
        
        // call user begin_of_run routine
        user_begin_of_run( RunNumber );
      }

      // Process Event
      int  eid;
      while( eid = mfile.readEvent(1) ){
        if ( !(eid & 0x8000) ){ // 0x8001=BOR,0x8002=EOR
          // Get adc0
          DWORD* pdataADC0 = 0;
          int adc0size = bk_locate( pevent, "ADC0", &pdataADC0 );
          AdcEvent adc0( 0, pheader, pdataADC0, adc0size, 1 );
          // Get trg1
          DWORD* pdataTRG1 = 0;
          int trg1size = bk_locate( pevent, "TRG1", &pdataTRG1 );
          int TrgBit = 0;
          if( trg1size > 0 )
            TrgBit = pdataTRG1[0] & 0xffff;
          
          // call user analysis routine
          user_process_event( RunNumber, TrgBit, adc0 );
        }
      }
    }
    else{
      std::cerr << "No such file : " << argv[i] << std::endl;
    }
  }
  //
  user_term();

  //
  return( 0 );
}

