// -*- C++ -*-
//
// VmeVisualScaler.h
// VME Visual Scaler accessing class
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Thu May 23 22:38:26 JST 2002
//
// $Id$
//
// Revision History
//
// $Log$
//

#ifndef  VMEVISUALSCALER_H_INCLUDED
#define  VMEVISUALSCALER_H_INCLUDED

// includes
#include <sys/vme.h>


//////
// constants
static const unsigned int  VMEVSCALER_RESET = 0x00;
static const unsigned int  VMEVSCALER_CH0   = 0x00;


//////
class VmeVisualScaler {
public:
  // constructor/destructor
  VmeVisualScaler();
  VmeVisualScaler( unsigned int baseaddr, int debugLevel=0 );
  ~VmeVisualScaler();
  // operator
  // static methods
  // methods
  void    reset();
  int     read( int reg );
private:
  // static data
  // data
  int              m_debugLevel;
  int              m_fd24;
  unsigned int     m_baseaddr;
  unsigned int     m_mapsize;
  unsigned short*  m_mapbase;
  unsigned short*  m_map;  
  // methods
  bool    init( unsigned int baseaddr );
};

//
#endif // VMEVISUALSCALER_H_INCLUDED
