#!/bin/tcsh -f

if ( $#argv < 2 ) then
    echo usage:$0 'run#(1001,1002,..,2670) Nevent'
    exit 1
endif

set runno = $1
set nev   = $2

#set INPUTDIR  = /:/.rw/hpss/ps/klea/montecarlo/collimator6/open
set INPUTDIR  = . 
set OUTPUTDIR = .
set LOGDIR    = .

set oname = e391a_r${runno}

### dump
echo 'run   =' ${runno}
echo 'nevent=' ${nev}
echo ''
echo 'OutputFiles:'
echo ${OUTPUTDIR}/${oname}.hbook
echo ${LOGDIR}/${oname}.log
echo ''
echo 'InputFile(s):'
ls ${INPUTDIR}/r${runno}.hbook

### start
setenv GSIM_INPUT ./gsim.dat

rm -f ${OUTPUTDIR}/${oname}.hbook
./gsim \
#    -ohpss \
    -o ${OUTPUTDIR}/${oname}.hbook \
#    -ihpss \
    -ihid 601 \
    -i ${INPUTDIR}/r${runno}.hbook ${nev} \
    >& ${LOGDIR}/${oname}.log
