// -*- C++ -*-
//
// GsimFFuser.cc
// User-Defined variables in the Input-Card (gsim.dat)
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Thu Jul 12 15:12:46 JST 2001
//
// $Id$
//
// Revision History
//
// $Log$
//
#include <iostream>
#include "ccfortran/ccfortran.h"
#include "ccfortran/G321Common.h"


//////
// GsimUserGeom.cc
extern int    DetUseCBAR[];
extern int    DetUseCS00[];
extern float  DetCS00[];
extern float  DetCSCI[];
extern float  DetCPB1[];
extern float  DetCPB2[];
// GsimHits.cc
extern float  DetEnergyThreshold;
// GsimUserGeom.cc
extern float  mfstep;
// Gukine.cc
extern float  MoveGenZ[];


//////
void
GsimFFuser()
{
  if ( gcflag_.ISWIT[3-1] > 0 )
    std::cerr << "GsimFFuser" << std::endl; 

  //
  FFKEY( "CBAR", DetUseCBAR,    2, "INTEGER" );
  FFKEY( "CS00", DetUseCS00,    2, "INTEGER" );
  FFKEY( "SS00", DetCS00,       2, "REAL" );
  FFKEY( "SSCI", DetCSCI,       2, "REAL" );
  FFKEY( "SPB1", DetCPB1,       2, "REAL" );
  FFKEY( "SPB2", DetCPB2,       2, "REAL" );
  //
  FFKEY( "ETHR", DetEnergyThreshold, 1, "REAL" );
  // GsimUserMate.cc
  FFKEY( "MFST", mfstep,        1, "REAL");
  // Gukine.cc
  FFKEY( "MVGZ", MoveGenZ,      2, "REAL");
}


