// -*- C++ -*-
//
// GsimGeom.cc
// Geometry definition function
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Thu Jul 12 15:12:46 JST 2001
//
// $Id$
//
// Revision History
//
// $Log$
//

#include <iostream>
#include <string>
#include <stdlib.h>
#include <math.h>
#include "CLHEP/Vector/ThreeVector.h"
#include "ccfortran/G321Common.h"
#include "ccfortran/ccfortran.h"
#include "gsim-general/GsimGeneral.h"
#include "gsim-general/GsimGeom.h"
#include "GsimUserGeom.h"


//////
#define  DEBUG  0


//////
extern void  GsimUserGeom_CentralBarrel();


//////
void
GsimRotationMatrix()
{
  //
  for( int i=0;i<32;i++ ){
    GSROTM( grot_z_32+i, 90, i*360./32,  90, i*360./32+90,  0, 0 );
  }
  //
  for( int i=0;i<32;i++ ){
    GSROTM( grot_x90_z_32+i, 90, i*360./32,  0, 0,  90, -90+i*360./32 );
  }
  //
  for( int i=0;i<32;i++ ){
    GSROTM( grot_y90_z_32+i, 180, 0,  90, 90+i*360./32,  90, i*360./32 );
  }
  
}


//////
void
GsimUserGeom()
{
  if ( gcflag_.ISWIT[3-1] > 0 )
    std::cerr << "GsimUserGeom" << std::endl; 

  //
  GsimRotationMatrix();

  //
  int  ivol=0;

  // Mother volume
  float p_moth[] = {400./2, 400./2, 2400./2 }; // x,y,z
  GSVOLU( "MOTH","BOX ",n_vacuum,p_moth,sizeof(p_moth)/sizeof(float),ivol );

  // Central Barrel
  GsimUserGeom_CentralBarrel();

  //
}


