// -*- C++ -*-
//
// GsimDetView.cc
// Drawing function
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Thu Jul 12 15:12:46 JST 2001
//
// $Id$
//
// Revision History
//
// $Log$
//
#include <iostream>
#include "ccfortran/ccfortran.h"
#include "ccfortran/G321Common.h"
#include "gsim-general/GsimGeneral.h"


//////
void
GsimUserView( int iview )
{
  if ( gcflag_.ISWIT[3-1] > 0 )
    std::cerr << "GsimUserView" << std::endl; 

  //
  if ( !isGxsim ) // Gxsim opens a display by itself.
    GDOPEN( 1 );

  //
  GSATT( "*","SEEN", 1 );
  GSATT( "MOTH","SEEN", 0 );

  if ( iview == 4 )
    GDRAW( "MOTH", disp_rotth,disp_rotph,disp_rotps, 10,10, 1,1 );
  else if ( iview == 3 ){
    GDRAWC( "MOTH", iview, 610, 10,10, 1,1 );
  }
  else
    GDRAWC( "MOTH", iview, 0, 10,10, 1,1 );

  GDCLOS();
  
  if ( isGxsim ){
    GDZOOM( 1, 1, 10,10, 10,10 );
  }
  else{
    GDZOOM( disp_zoom[0],disp_zoom[1], 10,10, disp_center[0],disp_center[1] );
    GDSHOW( 1 );
  }

  if ( disp_2buf > 0 )
    HPLSET( "2BUF",11 );
  
}
