// -*- C++ -*-
//
// guout.cc
// C++ interface of GUOUT with MIDAS bank system
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Wed Jul 11 15:29:57 JST 2001
//
// $Id$
//
// Revision History
//
// $Log$
//

#include <iostream>
#include "ccfortran/ccfortran.h"
#include "ccfortran/G321Common.h"
#include "gsim-general/GsimGeneral.h"
#include "ntuple.h"


//////
#define  DEBUG  0


// GsimHits.cc
extern int  GsimResults();


//////
void
Guout()
{
  if ( gcflag_.ISWIT[3-1] > 0 )
    std::cerr << "Guout" << std::endl;

  //
  int  mode = GsimGenParticle(); // decay mode: 0 = not decayed
  int  nhit = GsimResults();

  //
  nresult.EVTNO  = gcflag_.IEVENT;
  nresult.STATUS = mode;

  if ( Otuple && 
       ( ( SaveMode == 0 ) || 
         ( SaveMode == 1 &&  mode != 0 ) || 
         ( SaveMode == 2 && ( mode != 0 || nhit>0 ) ) ) ){
    Otuple->dump();
    //Ogenpart->dump();
    Ogsimrand->dump();
  }

  //
  if ( Display ){
    GDXYZ( 0 );
    IUWK( 0,1 );
  }

}
