// -*- C++ -*-
//
// GsimEvent.cc
// Event-Loop control function
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Thu Jul 12 15:34:41 JST 2001
//
// $Id$
//
// Revision History
//
// $Log$
//

#include <iostream>
#include <fstream>
#include "ccfortran/ccfortran.h"
#include "ccfortran/G321Common.h"
#include "gsim-general/GsimGeneral.h"
#include "gsim-general/Ntuple.h"


////////////////
int 
GsimEvent( int loop )
{
  int  Iseed1,Iseed2;

  // start
  gcflag_.IEVENT++;
  if ( gcflag_.ISWIT[3-1] > 0 )
    std::cerr << "GsimEvent: IEVENT=" << gcflag_.IEVENT << std::endl;

  // Set Random Number seed using RANECU's seed
  int  rindex=1;
  RANECQ( Iseed1, Iseed2, rindex, "R" );
  GRNDMQ( Iseed1, Iseed2, rindex, "S" );
  //std::cerr << " rseed=" << Iseed1 << "," << Iseed2 << " rindex=" << rindex 
  //     << std::endl;
  // bank
  gsim_rand.SEED1 = Iseed1;
  gsim_rand.SEED2 = Iseed2;
  
  if ( Display && gcflag_.ISWIT[8-1] >=  1 ){
    ICLRWK( 0, 0 );
    ISLN( 1 );
    GDSHOW( 1 );
  }

  // Process Event
  GTRIGI();
  GTRIG();
  GTRIGC();

  // Restore Random Number seed
  GRNDMQ( Iseed1, Iseed2, rindex, "G" );
  RANECQ( Iseed1, Iseed2, rindex, "S" );

  // Loop Counter
  int  ret = gcflag_.IDEVT;
  if ( --loop > 0 )
    gcflag_.IDEVT--;

  return( ret );
}


////////////////
int 
GsimEventSkip( int skip )
{
  return( gcflag_.IDEVT = skip );
}

