// -*- C++ -*-
//
// MidasBank.h
// Midas Bank Manager class
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Tue Jul 10 18:40:57 JST 2001
//
// $Id$
//
// Revision History
//
// $Log$
//

#ifndef MIDASBANK_H_INCLUDED
#define MIDASBANK_H_INCLUDED

#include <stdio.h>
#include "midas.h"


//////
class MidasBank {
public:
  MidasBank( int bufsize = EVENT_BUFFER_SIZE );
  MidasBank( const MidasBank& );
  ~MidasBank();
  //
  MidasBank&  operator=( const MidasBank& );
  //
  inline void*          eventBuffer() { return (void*)(eventHeader()+1); }
  inline EVENT_HEADER*  eventHeader();
  inline int            bufsize() { return m_bufsize; }
  bool                  realloc( int size );
  //
  void    init( int event_id,int mask, int serialnumber );
  int     getTable( char* name, size_t size, void* pdata );
  int     addTable( char* name, int TID_type, void* pdata,int bytes );

private:
  int     m_bufsize;
  char*   m_unalignedbuf;
  char*   m_unalignedbuf_w;
  //
};

// inline
inline EVENT_HEADER*
MidasBank::eventHeader()
{
  return (EVENT_HEADER*)ALIGN((PTYPE)m_unalignedbuf);
}

#endif //MIDASBANK_H_INCLUDED
