// -*- C++ -*-
//
// TMNtuple.h
// NTUPLE accessing classes
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Tue Sep 11 17:17:42 JST 2001
//
// $Id$
//
// Revision History
//
// $Log$
//

#ifndef TMNTUPLE_H_INCLUDED
#define TMNTUPLE_H_INCLUDED

//
#include <string>


//
class TupleManager;


//////
class TMNtuple {
public:
  TMNtuple( const TupleManager* );
  ~TMNtuple();
  //
  // CWN
  void  bookCWN( int hid, const std::string& title,
              const std::string& block, 
              void* vars, const std::string& cname );
  // CWN, read only
  void  bookCWN( int hid, const std::string& block, void* vars );

  // RWN by vars
  void  bookRWN( int hid, const std::string& title,
              void* vars, const std::string& varname );
  // RWN by name
  void  bookRWN( int hid, const std::string& title,
              const std::string& varname );
  // RWN by vars, read only
  void  bookRWN( int hid, void* vars );

  // Fill RWN members by name
  void  fill( const std::string& vname, float val );

  // dump data buffer to the output file
  int   dump();

  // RWN by name, clear the data
  void  clear();
  
  // read data block into &vars
  int   read( int eventNo );

  // hnoent()
  int   totalEntries();

private:
  //
  bool          m_bufinit;
  int           m_type; // TMN_CWN or TMN_RWN, see TupleManager.h
  std::string   m_title;
  std::string   m_block;
  std::string   m_cname;
  int           m_hid;
  int           m_nvars;
  float*        m_vars;
  int*          m_varindex; // RWN by internal vars
  std::string*  m_varname;  // RWN by internal vars
  const TupleManager* m_manager;
  
};


#endif // TMNTUPLE_H_INCLUDED

