// -*- C++ -*-
//
// AdcEvent.h
//
// Mon Jul 15 09:00:04 JST 2002
// Mitsuhiro YAMAGA
//
// $Id$
//
// $Log$
//

#ifndef ADCEVENT_H_INCLDUED
#define ADCEVENT_H_INCLDUED

//
#include <list>
#include "midas.h"
#include "AdcModule.h"


//
class AdcEvent {
public:
  // constructor
  AdcEvent();
  AdcEvent( int crate, const EVENT_HEADER* pheader, const DWORD* pdata, 
            int banksize, int nth_event=-1 );
  ~AdcEvent();
  // extractor
  const EVENT_HEADER&  eventHeader() const { return m_eventHeader; }
  int     serial() const { return m_serial; }
  int     crate()  const { return m_crate; }
  bool    valid()  const { return m_valid; }
  const std::list<AdcModule>&  adcList() const { return m_adcList; }
  const std::list<unsigned int>&  ngf() const { return m_ngf; }
  unsigned int  ngf( int nth ) const;
  unsigned int  trg() const { return m_trg; }
  //
  const AdcModule&  adc( int pa ) const;
  int     nhit() const;
  //
  int     unpack( int crate, const EVENT_HEADER* pheader, const DWORD* pdata, 
                  int banksize, int nth_event=-1 );
  void    setCrate( int crate ) { m_crate = crate; }
  void    setValid( bool valid ){ m_valid = valid; }
  int     ngf( const DWORD* pdata, int banksize );
  int     trg( const DWORD* pdata, int banksize );

private:
  // data
  EVENT_HEADER  m_eventHeader;
  int           m_serial;
  int           m_crate;
  bool          m_valid;
  std::list<AdcModule>     m_adcList;
  std::list<unsigned int>  m_ngf;
  unsigned int             m_trg;
  //
};


// inline


#endif // ADCEVENT_H_INCLDUED
